package com.pj.tb_import_order;

import com.pj.utils.sg.AjaxJson;
import com.pj.utils.so.SoMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;


/**
 * Controller: tb_import_order -- 进口申报单
 * @author lbl
 */
@RestController
@RequestMapping("/app/TbIportOrder/")
public class TbImportOrderAppController {

	/** 底层 Service 对象 */
	@Autowired
	TbImportOrderService tbImportOrderService;


	/** 改 */
	@RequestMapping("update")
	public AjaxJson update(TbImportOrder t){
		tbImportOrderService.update(t);
		return AjaxJson.getSuccess();
	}

	/** 查 - 根据id */
	@RequestMapping("getById")
	public AjaxJson getById(Long id){
		TbImportOrder t = tbImportOrderService.getById(id);
		return AjaxJson.getSuccessData(t);
	}

	/** 查集合 - 根据条件（参数为空时代表忽略指定条件） */
	@RequestMapping("getList")
	public AjaxJson getList() {
		SoMap so = SoMap.getRequestSoMap();
		List<TbImportOrder> list = tbImportOrderService.getList(so.startPage());
		return AjaxJson.getPageData(so.getDataCount(), list);
	}


}
