package com.pj.tb_import_order;

import java.util.Date;
import java.util.List;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.pj.api.client.async_server.AsyncServerInterface;
import com.pj.api.dto.HtIeportDeclBillsBpLimitDto;
import com.pj.api.dto.HtIeportDeclBillsGoodsDto;
import com.pj.api.dto.HtImportOrderDto;
import com.pj.enummj.DeleteStatus;
import com.pj.project4sp.SP;
import com.pj.tb_import_goods.TbImportGoods;
import com.pj.tb_import_goods.TbImportGoodsService;
import com.pj.tb_order.TbOrder;
import com.pj.tb_order.TbOrderService;
import com.pj.utils.so.SoMap;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.IService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.transaction.annotation.Transactional;

/**
 * Service: tb_import_order -- 进口申报单
 * @author lbl
 */
@Service
@Transactional(rollbackFor = Exception.class)
public class TbImportOrderService extends ServiceImpl<TbImportOrderMapper, TbImportOrder> implements IService<TbImportOrder>{

	/** 底层 Mapper 对象 */
	@Autowired
	TbImportOrderMapper tbImportOrderMapper;
	@Autowired
	TbOrderService tbOrderService;
	@Autowired
	TbImportGoodsService importGoodsService;
	@Autowired
	private AsyncServerInterface asyncServerInterface;

	/** 增 */
	void add(TbImportOrder t){
		save(t);
	}

	/** 删 */
	void delete(Long id){
		removeById(id);
	}

	/** 改 */
	void update(TbImportOrder t){
		updateById(t);

	}

	/** 查 */
	TbImportOrder getById(Long id){
		return super.getById(id);
	}

	/** 查集合 - 根据条件（参数为空时代表忽略指定条件） */
	List<TbImportOrder> getList(SoMap so) {
		return tbImportOrderMapper.getList(so);
	}

	/** 远程调用 进口申报单同步 */
	public boolean importOrderDto(HtImportOrderDto importOrderDto) {

		TbImportOrder importOrder = new TbImportOrder();
		BeanUtils.copyProperties(importOrderDto, importOrder);
		importOrder.setCreateName("航通");
		importOrder.setCreateTime(new Date());
		importOrder.setDeleteStatus(DeleteStatus.DELETE_STATUS_ON.getCode());
		boolean save = save(importOrder);
		long importOrderId = SP.publicMapper.getPrimarykey();
		if(true == save) {
			//委托边民额度
			List<HtIeportDeclBillsBpLimitDto> ieportDeclBillsBpLimitDtoList = JSON.parseArray(importOrderDto.getBorderPeopleLimitList(), HtIeportDeclBillsBpLimitDto.class);
			ieportDeclBillsBpLimitDtoList.forEach(ieportDeclBillsBpLimitDto -> {
				LambdaUpdateWrapper<TbOrder> wrapper = new LambdaUpdateWrapper<>();
				wrapper.set(TbOrder::getLimitNo, ieportDeclBillsBpLimitDto.getLimitNo());
				wrapper.set(TbOrder::getGLimit, ieportDeclBillsBpLimitDto.getgLimit());
				wrapper.set(TbOrder::getGNo, ieportDeclBillsBpLimitDto.getgNo());
				wrapper.set(TbOrder::getImportOrderId, importOrder);
				wrapper.eq(TbOrder::getPreIeportNo, ieportDeclBillsBpLimitDto.getPlatSeqNo());
				boolean update = tbOrderService.update(wrapper);
			});

			//申报单商品信息
			List<HtIeportDeclBillsGoodsDto> ieportDeclBillsGoodsDtoList = JSON.parseArray(importOrderDto.getGoodsList(), HtIeportDeclBillsGoodsDto.class);
			ieportDeclBillsGoodsDtoList.forEach(ieportDeclBillsGoodsDto -> {
				TbImportGoods importGoods = new TbImportGoods();
				BeanUtils.copyProperties(ieportDeclBillsGoodsDto, importGoods);
				importGoods.setImportOrderId(importOrderId);
				boolean save1 = importGoodsService.save(importGoods);
			});
		}
		return save;
	}
}
